﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WillBe.Framework
{
    public abstract class WillBeActionBase<T> :IDoAttributeAction<T>
        where T : WillBeAttribute
    {
        public void Init(T attribute, ProcessingRequest request, Action action)
        {
            Attribute = attribute;
            Request = request; 
            Action = action;
        }

        protected T Attribute;
        protected ProcessingRequest Request;
        protected Action Action;

        abstract public void Do();
    }
}
